import 'package:daggerito/daggerito.dart';
import 'package:flutter/material.dart';
import 'package:kohana/kohana.dart';

// ignore: must_be_immutable
abstract class HasComponentView<T> extends StatefulView<T> {
  final Component component;

  HasComponentView(this.component);

  T call<T>([String? tag]) => component.container.resolve<T>(tag);

  @override
  Widget build(BuildContext context) {
    commonDependencies(context);
    runHooks();
    return buildWidget(context);
  }

  void commonDependencies(BuildContext context) {
    // referesh dependency upon every build example
  }

  @override
  FieldsFactory<T?> setup() => () => null;
}
