import 'package:kohana/kohana.dart';
import 'package:rxdart/rxdart.dart';

import 'base_input_field.dart';

class BooleanInputField extends BaseInputField<bool> {
  BooleanInputField({
    bool? value = false,
    TextFieldValidator? validator,
    InputStreamBuilder<bool>? inputStreamBuilder,
  }) : super(
          value != null ? BehaviorSubject.seeded(value) : BehaviorSubject(),
          validator,
          inputStreamBuilder: inputStreamBuilder,
        );

  Stream<String> get streamAsString => stream.map((event) => event.toString());

  Consumer<InputValue> get asInputValueConsumer =>
      (inputValue) => subject.add(inputValue.value.toLowerCase() == 'true');
}
