import 'dart:async';

abstract class HasModelField<T extends LifecycleAware> implements LifecycleAware {
  T get model;

  @override
  FutureOr start() async {
      model.start();
  }

  @override
  FutureOr dispose() async {
      await model.dispose();
  }
}

abstract class Disposable {
  FutureOr dispose() {}
}
abstract class LifecycleAware extends Disposable{
  FutureOr start() {}

}

typedef FutureOr Func();
